SystemOrganization addCategory: #ProjectPOC!

Morph subclass: #AthensDemoMorphMyChanges
	instanceVariableNames: 'surface animations current zooming scale frame pharoLogo esugBallon button1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProjectPOC'!

!AthensDemoMorphMyChanges commentStamp: 'jChizmar 7/9/2015 05:36' prior: 0!
My Changes to the Demo!

!AthensDemoMorphMyChanges class methodsFor: 'examples' stamp: 'jChizmar 7/9/2015 07:17'!
example
	"self example"
	
	| demo model window |
	demo := AthensDemoMorphMyChanges new openInWorld. 
	(model := DynamicComposableModel new)
		instantiateModels: #(backButton ButtonModel forwardButton ButtonModel).
	model backButton label: 'Previous Figure'; action: [ demo prevFigure ].
	model forwardButton label: 'Next Figure'; action: [ demo nextFigure ].
	window := model openWithSpecLayout: (SpecLayout composed
 				   newColumn: [: c | c add: #backButton. c add: #forwardButton ];
    				   yourself).
	window title: 'Athens demos'! !

!AthensDemoMorphMyChanges methodsFor: 'initialize-release' stamp: 'jChizmar 7/9/2015 05:35'!
backColor
	^ Color white.! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 07:26'!
carColor
	^ Color veryVeryLightGray! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 05:35'!
chasisDecoratorColor
	^ Color black! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 05:35'!
chasisLineColor
	^ Color white! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 05:35'!
coloredCarColor
	^ Color red! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 05:35'!
defaultExtent
	^ 400@400! !

!AthensDemoMorphMyChanges methodsFor: 'drawing' stamp: 'jChizmar 7/9/2015 07:14'!
drawBackgroundOn: aCanvas
	aCanvas setPaint: Color red; drawShape: (0@0 extent: 1@1)! !

!AthensDemoMorphMyChanges methodsFor: 'drawing' stamp: 'jChizmar 7/9/2015 05:35'!
drawCarOn: aCanvas
	"chasis -----------------------------------------------------------------------"
		| p stroke wheel decorator |
	p := aCanvas createPath:[:b|
			b 
				moveTo: 0.3@0.3 ;
				lineTo: 0.4@0;
				curveVia: 0.1@0 to: 0.1@0.1;
				lineTo: 0@0.2;
				curveVia: 0@0.1 to: -0.1@0.1;
				lineTo: -0.4@0;
				curveVia: -0.1@0 to: (0.1@0.1) negated;
				lineTo: 0@0.2 negated ;
				curveVia: 0@0.1 negated to: 0.1@0.1 negated ].
		aCanvas	
			setPaint: self coloredCarColor;
			drawShape: p.
		stroke := aCanvas setStrokePaint: self wheelColor.
		stroke width: 0.01.
		aCanvas draw.
		
		"wheels-----------------------------------------------------------------------"
		wheel := aCanvas createPath:[:b|
			b
				moveTo: 	0.3@0.3;		
				cwArcTo: 0.15@0 angle: Float halfPi ;
				moveTo: 	0.1@0;				
				cwArcTo: 0.15@0 angle: Float halfPi ;					
				moveTo: 	0.0@0.4;				
				cwArcTo: 0.15 negated@0 angle: Float halfPi; 
				moveTo: 	-0.1@0; 
				cwArcTo: 0.15 negated@0 angle: Float halfPi 	].
		aCanvas	
			setPaint: self wheelColor;
			drawShape: wheel.
		
		"chasis decorator-----------------------------------------------------------------------"
		decorator  := aCanvas createPath:[:b|
			b
				moveTo: 	0.2@0.45;	
				lineTo: 0.225@0 ;		
				cwArcTo: 0.15@0 angle: Float halfPi ;
				lineTo: 	0.225@0;				
				lineTo: 0@0.1 ;
				lineTo: -0.225@ 0;
				cwArcTo: -0.15@0 angle: Float halfPi ;
				lineTo: -0.225@ 0	;
				lineTo: 0@0.1 negated].
		stroke := aCanvas setStrokePaint: self chasisDecoratorColor.
		stroke width: 0.01.	
		aCanvas drawShape: decorator.
		aCanvas setPaint: self chasisLineColor.
		aCanvas draw.		
			
			! !

!AthensDemoMorphMyChanges methodsFor: 'drawing' stamp: 'jChizmar 7/9/2015 05:35'!
drawOn: aCanvas

	self render.

	aCanvas
		drawImage: surface asForm at: self bounds origin! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure10: aCanvas
	| pt ellipsePath patternPaint rectangle |
	ellipsePath := aCanvas createPath: [ :builder |
		builder
			moveTo: 0@200;
			cwArcTo: 240@0  angle: Float pi ;
			 cwArcTo: -240@0 angle: Float pi ].
	aCanvas setPaint: Color black.
	aCanvas drawShape: ellipsePath.
	rectangle := 250@40 extent: 140@300.
	aCanvas drawShape: rectangle.


	aCanvas paintTransform loadIdentity.
	aCanvas paintTransform scaleBy: ((frame/100) sin abs)*5.
	aCanvas paintTransform rotateByDegrees: (frame/100) sin * 360.
	
	patternPaint := aCanvas setPaint: pharoLogo.
	patternPaint setExtend: #Repeat.
	aCanvas drawShape: ellipsePath.
	
	aCanvas setPaint: patternPaint.
	patternPaint setExtend: #Reflect.
	aCanvas drawShape: rectangle.
! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 07:29'!
figure1: aCanvas
	
	aCanvas
		setPaint: self carColor;
		drawShape: (50@100 extent: 300@200);
		setPaint: Color red;
		drawShape: (0@10 extent: 300@200); 
		setPaint: self carColor;
		drawShape: (50@100 extent: 300@200).
		! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure2: aCanvas
	| pt path |
	
	path := aCanvas createPath: [:builder |
		builder
			absolute;
			moveTo: 70@100;
			lineTo: 330@100;
			cwArcTo: 350@120 angle: 90 degreesToRadians;
			lineTo: 350@280;
			cwArcTo: 330@300 angle: 90 degreesToRadians;
			lineTo: 70@300;
			cwArcTo: 50@280 angle: 90 degreesToRadians;
			lineTo: 50@120;
			cwArcTo: 70@100 angle: 90 degreesToRadians
	].

	aCanvas
		setPaint: self carColor;
		drawShape: path 
! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure3: aCanvas
	| pt path |
	
	path := aCanvas createPath: [:builder |
		builder
			relative;
			moveTo: 0.3@0.3 ;
			lineTo: 0.4@0;
			curveVia: 0.1@0 to: 0.1@0.1;
			lineTo: 0@0.2;
			curveVia: 0@0.1 to: -0.1@0.1;
			lineTo: -0.4@0;
			curveVia: -0.1@0 to: (-0.1@ -0.1);
			lineTo: 0@ -0.2  ;
			curveVia: 0@ -0.1 to: 0.1@ -0.1 ].

	aCanvas pathTransform scaleBy: self extent.
	aCanvas
		setPaint: self carColor;
		drawShape: path 
! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure4: aCanvas
	| path stroke |
	
	path := self roundedRectanglePathOn: aCanvas.
	
	aCanvas setShape: path.
	
	aCanvas setPaint: self carColor.
	aCanvas draw.
	
	stroke := aCanvas setStrokePaint: Color black.
	stroke width: 3.
	
	aCanvas draw. ! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure5: aCanvas
	| wheels |
	self figure4: aCanvas.

	wheels := aCanvas createPath: [:builder |
		builder
			moveTo:  100@100;		
			cwArcTo: 60@0 angle: 90 degreesToRadians;
			moveTo:  80@0;				
			cwArcTo: 60@0 angle: 90 degreesToRadians;
			moveTo:  0.0@200;
			cwArcTo: -60@0 angle: 90 degreesToRadians;
			moveTo:  -80@0; 
			cwArcTo: -60@0 angle: 90 degreesToRadians ].

	aCanvas	
		setPaint: self wheelColor;
		drawShape: wheels! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure6: aCanvas
	| pt c linearGradient |
	
	self figure5: aCanvas.
	
	linearGradient := 
		aCanvas surface createLinearGradient: {
			0 -> self coloredCarColor .
			0.25 -> self coloredCarColor muchLighter.
			0.5 -> Color white.
			0.75 -> (self coloredCarColor muchLighter ).
			1 -> (self coloredCarColor alpha: 0)	
		}
		start:  0@100  
		stop: 0@300.
	
	aCanvas setShape: (self roundedRectanglePathOn: aCanvas).
	
	aCanvas setPaint: linearGradient.
	
	aCanvas draw.
		! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure7: aCanvas
	| pt |

	self drawBackgroundOn: aCanvas.

	pt := aCanvas pathTransform.

	pt restoreAfter:[

		pt scaleBy: self extent .
		self drawCarOn: aCanvas.

		pt scaleBy: 0.25@0.25. 
		self drawCarOn: aCanvas.
	
		pt  translateBy: 2@0; rotateByDegrees: 35.
		self drawCarOn: aCanvas.
	].
		! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure8: aCanvas
	| pt |
	pt := aCanvas pathTransform.
	pt restoreAfter:[
		| stroke p  wheel decorator |
		pt scaleBy: self extent .
		self drawBackgroundOn: aCanvas.

		pt scaleBy: (frame/100) sin abs.
		self drawCarOn: aCanvas.
		pt scaleBy: 0.25@0.2.5. 
		self drawCarOn: aCanvas.
	
		pt  translateBy: 2@0; rotateByDegrees: 35.
		self drawCarOn: aCanvas.
	
	  ].
		! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
figure9: aCanvas
	| pt ellipsePath patternPaint |
	ellipsePath := aCanvas createPath: [ :builder |
		builder
			moveTo: 10@200;
			cwArcTo: 360@0  angle: Float pi ;
			lineTo: -100@180;
			lineTo: -150@ -0;
			lineTo: -110@ -180].

	aCanvas setPaint: Color black.
	aCanvas drawShape: ellipsePath.

	aCanvas paintTransform loadIdentity.
	aCanvas paintTransform scaleBy: ((frame/200) sin abs)*3.
	
	
	patternPaint := aCanvas setPaint: esugBallon .
	patternPaint setExtend: #None.
	aCanvas draw.! !

!AthensDemoMorphMyChanges methodsFor: 'initialize-release' stamp: 'jChizmar 7/9/2015 05:35'!
figures
	^ #(
	figure1:
	figure2:
	figure3:
	figure4:
	figure5:
	figure6:
	figure7:
	figure8:
	figure9:
	figure10:
	).
	
	! !

!AthensDemoMorphMyChanges methodsFor: 'initialize-release' stamp: 'jChizmar 7/9/2015 20:53'!
initialize 
	| ref loadFileFailBlock|
	super initialize.
	self extent: self defaultExtent.
	self color: self backColor.
	surface := AthensCairoSurface extent: self extent.
	current := 1.
	frame := 0.
      loadFileFailBlock:= AthensCairoSurface fromForm:(Form fromDisplay: (0@0 extent:(300@150))).
	ref := 	'Pharo.png' asFileReference.
	pharoLogo := AthensCairoSurface createFromFile:  ref fullName ifFailed:  [ loadFileFailBlock ].

	ref := 'esug-balloon.png' asFileReference.
	esugBallon := AthensCairoSurface createFromFile:  ref fullName ifFailed:  [ loadFileFailBlock ].
	
 	button1 := InputButton text: 'Push Me'. 
	button1 labelString: 'Push Me'; minWidth: 100.
	button1 mouseAction: [ Transcript show: 'Hi Jen'] .


	self addMorph: button1.
	self startStepping.
	! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 05:35'!
nextFigure

	current := current + 1.
	
	current > self figures size ifTrue: [ current := 1 ].! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 05:35'!
prevFigure

	current := current - 1.
	
	current < 1 ifTrue: [ current := self figures size ].! !

!AthensDemoMorphMyChanges methodsFor: 'drawing' stamp: 'jChizmar 7/9/2015 07:15'!
render 

	surface drawDuring: [:canvas | 
		surface clear.
		canvas pathTransform loadIdentity.
		canvas setPaint: Color blue;
		drawShape: (0@0 corner: self extent).
		self perform: (self figures at: current)  with: canvas
	].
! !

!AthensDemoMorphMyChanges methodsFor: 'figures' stamp: 'jChizmar 7/9/2015 05:35'!
roundedRectanglePathOn: aCanvas

	^ aCanvas createPath: [:builder |
		builder
			absolute;
			moveTo: 70@100;
			lineTo: 330@100;
			cwArcTo: 350@120 angle: 90 degreesToRadians;
			lineTo: 350@280;
			cwArcTo: 330@300 angle: 90 degreesToRadians;
			lineTo: 70@300;
			cwArcTo: 50@280 angle: 90 degreesToRadians;
			lineTo: 50@120;
			cwArcTo: 70@100 angle: 90 degreesToRadians
	].

! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 05:35'!
step
	frame := frame + 1.
	self changed! !

!AthensDemoMorphMyChanges methodsFor: 'accessing' stamp: 'jChizmar 7/9/2015 05:35'!
stepTime
	^ 0! !

!AthensDemoMorphMyChanges methodsFor: 'drawing' stamp: 'jChizmar 7/9/2015 05:35'!
wheelColor
	^ Color brown darker! !

SimpleButtonMorph subclass: #InputButton
	instanceVariableNames: 'mouseAction labelText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProjectPOC'!

!InputButton commentStamp: 'jChizmar 7/9/2015 07:56' prior: 0!
A button that responds to input!

!InputButton class methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 12:47'!
text:labelText
	"comment stating purpose of message"
	super initialize.
^ self new.! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 11:54'!
labelText:labelTextIn
labelText := labelTextIn.
^self
! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 20:50'!
mouseAction: t1
	^ mouseAction := t1! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 20:54'!
mouseUp: t1
	mouseAction value.
	^ self! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 12:45'!
text:labelTextIn
labelText := labelTextIn.

^self
! !
